-----------------------------------------------------------------------------
-- |
-- Module      :  HSP.Response
-- Copyright   :  (c) Niklas Broberg 2004,
-- License     :  BSD-style (see the file LICENSE.txt)
-- 
-- Maintainer  :  Niklas Broberg, d00nibro@dtek.chalmers.se
-- Stability   :  experimental
-- Portability :  requires undecidable and overlapping instances
--
-- Defines the Response object available to HSP pages.
-----------------------------------------------------------------------------
module HSP.Response (
	setOutgoingHeader	-- ^ :: Response -> String -> String -> IO ()
	) where

import qualified HSP.Data.Response as Rp
import HSP.Data

-- | Add a header to the outgoing response generated for
-- this page.
setOutgoingHeader :: String -> String -> HSP ()
setOutgoingHeader hdn hdv = do
	resp <- getResponse
	doIO $ Rp.setOutgoingHeader resp hdn hdv
